<?php

class fieldMapsis extends cmsFormField {

    public $title = 		'Координаты (MapsIS)';
    public $sql = 			'varchar(255) NULL DEFAULT NULL';
    public $filter_type     = false;
	public $allow_index 	= false;

    public function getOptions(){

        return array(
            new fieldNumber('mapsis_zoom', array(
                'title' => 'Масштаб',
                'default' => 12,
            )),
            new fieldNumber('mapsis_height', array(
                'title' => 'Высота',
                'default' => 250,
                'hint' => 'В пикселях.',
            )),
            new fieldCheckbox('mapsis_google', array(
                'title' => 'Карта Google',
                'default' => 0,
            )),
            new fieldCheckbox('mapsis_yandex', array(
                'title' => 'Карта Яндекс',
                'default' => 0,
            )),
            new fieldCheckbox('mapsis_weather', array(
                'title' => 'Карта Google (погода)',
                'default' => 0,
            ))
        );
    }

    public function parse($value){

			$maps = '
				<div id="maps_field">
			';

			if (($this->getOption('mapsis_google')==1 && $this->getOption('mapsis_weather')==1) || ($this->getOption('mapsis_google')==0 && $this->getOption('mapsis_weather')==1)){
				$maps .= '
					<script type="text/javascript" src="https://maps.googleapis.com/maps/api/js?v=3.exp&key=AIzaSyC1WHBu7W9npwFZgABlFjmdjIxr3ZRiaaI&language=ru&libraries=weather"></script>
				';	
			}

			elseif ($this->getOption('mapsis_google')==1 && $this->getOption('mapsis_weather')==0){
				$maps .= '
					<script type="text/javascript" src="https://maps.googleapis.com/maps/api/js?v=3.exp&key=AIzaSyC1WHBu7W9npwFZgABlFjmdjIxr3ZRiaaI&language=ru"></script>
				';	
			}

			if ($this->getOption('mapsis_google')==1){
				$maps .= '
					<div id="gmap_field" style="width:100%;height:'.htmlspecialchars($this->getOption('mapsis_height')).'px;margin-top:10px;"></div>
					<script type="text/javascript">
						function initialize_gmap_field() {
							var gmap;
							var marker;
							var latlng = new google.maps.LatLng('.htmlspecialchars($value).');
							var geocoder = new google.maps.Geocoder();
							var infowindow = new google.maps.InfoWindow();
							var mapOptions = { zoom: '.htmlspecialchars($this->getOption('mapsis_zoom')).', center: latlng };
							gmap = new google.maps.Map(document.getElementById("gmap_field"), mapOptions);
							marker = new google.maps.Marker({map: gmap, animation: google.maps.Animation.DROP, position: latlng});
							geocoder.geocode({"latLng": latlng}, function(results, status) {
								if (status == google.maps.GeocoderStatus.OK) {
									if (results[0]) {
										infowindow.setContent(results[0].formatted_address);
										google.maps.event.addListener(marker, "click", function() { infowindow.open(gmap, marker); });
									}
								}
							});
						}
						google.maps.event.addDomListener(window, "load", initialize_gmap_field);
					</script>
				';
			}

			if ($this->getOption('mapsis_yandex')==1){
				$maps .= '
					<script src="http://api-maps.yandex.ru/2.1/?lang=ru_RU" type="text/javascript"> </script>
					<div id="ymap_field" style="width:100%;height:'.htmlspecialchars($this->getOption('mapsis_height')).'px;margin-top:10px;"></div>
					<script type="text/javascript">
						ymaps.ready(init);
						function init() {
							var myMap = new ymaps.Map("ymap_field", { center: ['.htmlspecialchars($value).'], zoom: '.htmlspecialchars($this->getOption('mapsis_zoom')).', controls: ["smallMapDefaultSet"] });
							var myPlacemark = new ymaps.Placemark(['.htmlspecialchars($value).'],{}, {preset: "islands#blueDotIcon"});
							ymaps.geocode(myMap.getCenter()).then(function (res) {
								var firstGeoObject = res.geoObjects.get(0);
								myPlacemark.properties.set({ balloonContent: firstGeoObject.properties.get("text") });
							});
							myMap.geoObjects.add(myPlacemark);
						}
					</script>
				';
			}

			if ($this->getOption('mapsis_weather')==1){
				$maps .= '
					<div id="wmap_field" style="width:100%;height:'.htmlspecialchars($this->getOption('mapsis_height')).'px;margin-top:10px;"></div>
					<script type="text/javascript">
						function initialize_mapsis_weather() {
							var wmap;
							var latlng = new google.maps.LatLng('.htmlspecialchars($value).');
							var mapOptions = { zoom: '.htmlspecialchars($this->getOption('mapsis_zoom')).', center: latlng, mapTypeControl: false, streetViewControl: false };
							wmap = new google.maps.Map(document.getElementById("wmap_field"), mapOptions);
							var weatherLayer = new google.maps.weather.WeatherLayer({temperatureUnits: google.maps.weather.TemperatureUnit.CELSIUS});
							weatherLayer.setMap(wmap);
							var cloudLayer = new google.maps.weather.CloudLayer();
							cloudLayer.setMap(wmap);
						}
						google.maps.event.addDomListener(window, "load", initialize_mapsis_weather);
					</script>
				';
			}

			$maps .= '
				</div>
			';

			return $maps;

	}

    public function getFilterInput($value){

        return false;

    }

    public function parseTeaser($value) {

        return htmlspecialchars($value);

    }
	
}